#include <stdio.h>




void initSerpBG( unsigned short *bg, int s ) {
	unsigned short *p = bg + 32*10;
	int n, m;

	for (n = 0; n < 32*32; n++) {
		bg[n] = 0;
	}
	for (n = 0, m = 1; n < 16; n++) {
		// first column..
		*p++ = s + m + 0;
		*p++ = s + m + 1;
		*p++ = s + m + 2;
		p += 7;

		// second column..
		*p++ = s + 0x5f - m;
		*p++ = s + 0x60 - m;
		*p++ = s + 0x61 - m;
		p += 7;

		// third column..
		*p++ = s + 0x60 + m;
		*p++ = s + 0x61 + m;
		*p++ = s + 0x62 + m;
		p += 9;
		m += 3;
	}
}


int main (int argc, char **argv ) {
	unsigned short bg1[32*32];
	unsigned short bg2[32*32];
	int m,n;
	
	
	initSerpBG(bg1,0x00);
	initSerpBG(bg2,0x90);
	

	for (m = 0; m < 32*32; m += 32) {
		for (n = m; n < m+32; n++) {
			printf("%03x ",bg1[n]);
		}
		printf("\n");
	}

	printf("\n\n");

	for (m = 0; m < 32*32; m += 32) {
		for (n = m; n < m+32; n++) {
			printf("%03x ",bg2[n]);
		}
		printf("\n");
	}



	return 0;
}
