//
//
//

#include "intro.h"
#include "options.h"

//
// some constants
//

RODATA const char *on4  = "ON  ";
RODATA const char *off4 = "OFF ";
RODATA const char *emp4 = "    ";

//
//
//

void int2dec( unsigned int i, char *b ) {
	unsigned int m = 1000000000;
	int leading = 1;
	int d;

	if (i == 0) {
		*b++ = '0';
		*b++ = '\0';
		return;
	}

	do {
		d = i / m;
		if (leading && d > 0) {
			leading = 0;
		}
		if (!leading) {
			*b++ = d + '0';
		}
		i -= d*m;
		m /= 10;
	} while (m > 0);

	*b++ = '\0';
}

//

int basicToggle(int ctrl, unsigned short *scr, char *str, void (*print)(int, unsigned short *,char *)) {
	if (ctrl == TOGGLE_NONE) {
		print(0,scr,str);
	}
	if (ctrl & TOGGLE_NONE || ctrl & TOGGLE_B) {
		print(26,scr,off4);
		return 0;
	}
	if (ctrl & TOGGLE_A) {
		print(26,scr,on4);
		return 1;
	}
	return 0;
}

//
//
//

int basicCount(int ctrl, int val, unsigned short *scr, char *str, void (*print)(int, unsigned short *,char *)) {
	char buf[12];

	if (ctrl == TOGGLE_NONE) {
		print(0,scr,str);
	}

	print(26,scr,emp4);
	int2dec(val,buf);
	print(26,scr,buf);

	if (ctrl & TOGGLE_A) { val++; }
	if (ctrl & TOGGLE_B) { val--; }
	return val;
}



//
//
//
//
//
//
//
//
//

int exitMenu( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	print(2,scr,"*** -START-THE-GAME- ***");
	return 1;
}

int dashes( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	print(0,scr,"------------------------------");
	return 0;
}

int textline0( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	print(0,scr,"*** A LAMMAH! TRAINER MENU ***");
	return 0;
}

int textline1( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	print(0,scr,"CODE: MR.SPIV/TRSI");
	return 0;
}

int textline2( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	print(0,scr,"MUSIC: WOTW/EX-TRSI");
	return 0;
}

int textline3( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	print(0,scr,"GFX: J.O.E/EX-TRSI,WAL/DAMONES");
	return 0;
}



//
//
//

int onOff0( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}
int onOff1( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}
int onOff2( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}


int onOff3( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff4( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff5( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff6( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	static char *str = "THIS IS TRAINER OPTION 6";
	basicToggle(ctrl,scr,str,print);
	return 0;
}

int onOff7( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	static char *str = "THIS IS TRAINER OPTION 7";
	basicToggle(ctrl,scr,str,print);
	return 0;
}

int onOff8( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	static char *str = "THIS IS TRAINER OPTION 8";
	basicToggle(ctrl,scr,str,print);
	return 0;
}

int onOff9( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	static char *str = "THIS IS TRAINER OPTION 9";
	basicToggle(ctrl,scr,str,print);
	return 0;
}

int onOff10( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff11( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff12( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	static char *str = "THIS IS TRAINER OPTION 12";
	basicToggle(ctrl,scr,str,print);



	return 0;
}

int onOff13( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	static char *str = "THIS IS TRAINER OPTION 13";
	basicToggle(ctrl,scr,str,print);



	return 0;
}

int onOff14( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	static char *str = "THIS IS TRAINER OPTION 14";
	basicToggle(ctrl,scr,str,print);



	return 0;
}

int onOff15( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	static char *str = "THIS IS TRAINER OPTION 15";
	basicToggle(ctrl,scr,str,print);



	return 0;
}

int onOff16( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff17( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff18( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff19( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff20( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff21( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff22( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff23( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff24( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff25( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff26( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff27( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff28( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff29( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff30( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int onOff31( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

//
//
//

int count0( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}
int count1( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}
int count2( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}


int count3( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count4( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count5( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	static char *str = "NUMBER OF ODDS";
	static unsigned int val = 11;
	char buf[12];

	if (ctrl == TOGGLE_NONE) {
		print(0,scr,str);
	}

	print(26,scr,emp4);
	int2dec(val,buf);
	print(26,scr,buf);

	if (ctrl == TOGGLE_A) { val += 2; }
	if ((ctrl == TOGGLE_B) && (val >= 3)) { val -= 2; }

	if (val > 99) { val = 99; }
	return 0;
}

int count6( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count7( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count8( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count9( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count10( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	static char *str = "NUMBER OF LIVES";
	static unsigned int cnt = 5;

	cnt = basicCount(ctrl,cnt,scr,str,print);
	if (cnt > 15) { cnt = 15; }
	if (cnt < 3) { cnt = 3; }

	return 0;
}

int count11( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {
	static char *str = "START LEVEL";
	static unsigned int cnt = 0;

	cnt = basicCount(ctrl,cnt,scr,str,print);
	cnt %= 7;

	return 0;
}

int count12( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count13( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count14( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count15( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count16( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count17( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count18( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count19( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count20( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count21( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count22( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count23( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count24( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count25( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count26( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count27( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count28( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count29( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count30( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}

int count31( int ctrl,  unsigned short *scr, void (*print)(int, unsigned short *,char *)) {



	return 0;
}
